#ifndef EDIT_PROJDIALOG_IS_INCLUDED
#define EDIT_PROJDIALOG_IS_INCLUDED
/* { */

#include "../fsgui3dapp.h"
#include "../miscdlg.h"
#include <ysglbuffer.h>

// Implemented in editmenu.cpp
class PolyCreProjectionDialog : public FsGuiDialog
{
public:
	FsGui3DMainCanvas *canvas;
	FsGuiButton *okBtn,*cancelBtn;
	FsGuiDropList *projDirDrp;
	FsGuiDropList *projTargetDrp;

	YsArray <YsPair <YsShellVertexHandle,YsVec3> > vertexPositionPair;
	YsGLVertexBuffer lineBuf;
	YsGLVertexBuffer triBuf;

private:
	PolyCreProjectionDialog();
	~PolyCreProjectionDialog();

public:
	static PolyCreProjectionDialog *Create(FsGui3DMainCanvas *canvas);
	static void Delete(PolyCreProjectionDialog *ptr);

	void Make(void);
	YSRESULT RemakeVertexProjectionArray(void);
	YSRESULT RemakeDrawingBuffer(void);
private:
	YSRESULT CalculateProjectionPlane(YsPlane &pln) const;
	YSRESULT CalculateProjectionDirection(YsVec3 &dir,const YsPlane &pln) const;
	YsArray <YsShellVertexHandle> GetVertexToBeMoved(void) const;

public:
	virtual void OnDropListSelChange(FsGuiDropList *drp,int);
	virtual void OnButtonClick(FsGuiButton *btn);
};


/* } */
#endif
