#ifndef YSSHELLEXT_PATCHUTIL_IS_INCLUDED
#define YSSHELLEXT_PATCHUTIL_IS_INCLUDED
/* { */

#include <ysshellext.h>

class YsShellExt_PatchBetweenTwoConstEdge
{
public:
	enum PATCHSTRATEGY
	{
		UNIFORM_PARAMETER
	};

	YsShellExt shl;
	YsHashTable <YsShellVertexHandle> patchVtKeyToSrcVtHd;
	YsHashTable <int> patchVtKeyToSeqId;

	YsArray <YsShellVertexHandle> rawVtHdSeq[2],vtHdSeq[2];
	YsArray <double> paramArray[2];
	YSBOOL isLoop[2];

	YsShellExt::ConstEdgeHandle seqCeHd[2];

	double totalLen[2];


	YsShellExt_PatchBetweenTwoConstEdge();
	~YsShellExt_PatchBetweenTwoConstEdge();

	void CleanUp(void);
	YSRESULT SetVertexSequence(const YsShell &srcShl,
	                       YSSIZE_T nVt0,const YsShellVertexHandle vtHdArray0[],YSBOOL isLoop0,
	                       YSSIZE_T nVt1,const YsShellVertexHandle vtHdArray1[],YSBOOL isLoop1);

	template <const int N>
	YSRESULT SetVertexSequence(const YsShell &srcShl,
	                       const YsArray <YsShellVertexHandle,N> &vtHdArray0,YSBOOL isLoop0,
	                       const YsArray <YsShellVertexHandle,N> &vtHdArray1,YSBOOL isLoop1);

	template <const int N>
	YSRESULT SetVertexSequence(const YsShell &srcShl,
	                       const YsArray <YsShellVertexHandle,N> vtHdArray[2],const YSBOOL isLoop[2]);

	void CalculateParameter(void);
	void MakeInitialGuess(void);
	void MinimizeDihedralAngleSum(void);

	template <const int N>
	void GetPolygonVertexOfOriginalShell(YsArray <YsShellVertexHandle,N> &plVtHd,YsVec3 &nom,YsShellPolygonHandle patchPlHd);
};

template <const int N>
YSRESULT YsShellExt_PatchBetweenTwoConstEdge::SetVertexSequence(const YsShell &srcShl,
                       const YsArray <YsShellVertexHandle,N> &vtHdArray0,YSBOOL isLoop0,
                       const YsArray <YsShellVertexHandle,N> &vtHdArray1,YSBOOL isLoop1)
{
	return SetVertexSequence(srcShl,vtHdArray0.GetN(),vtHdArray0,isLoop0,vtHdArray1.GetN(),vtHdArray1,isLoop1);
}

template <const int N>
YSRESULT YsShellExt_PatchBetweenTwoConstEdge::SetVertexSequence(const YsShell &srcShl,
                       const YsArray <YsShellVertexHandle,N> vtHdArray[2],const YSBOOL isLoop[2])
{
	return SetVertexSequence(srcShl,vtHdArray[0],isLoop[0],vtHdArray[1],isLoop[1]);
}

template <const int N>
void YsShellExt_PatchBetweenTwoConstEdge::GetPolygonVertexOfOriginalShell(YsArray <YsShellVertexHandle,N> &plVtHd,YsVec3 &nom,YsShellPolygonHandle patchPlHd)
{
	nom=shl.GetNormal(patchPlHd);
	shl.GetPolygon(plVtHd,patchPlHd);
	for(auto &vtHd : plVtHd)
	{
		patchVtKeyToSrcVtHd.FindElement(vtHd,shl.GetSearchKey(vtHd));
	}
}


/* } */
#endif
