/* ////////////////////////////////////////////////////////////

  File Name: ysshellextedit_copyutil.cpp
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#include "ysshellextedit_copyutil.h"

YSRESULT YsShellExt_CopyPolygonAttribColorNormal(YsShellExtEdit &outShl,YsShellPolygonHandle outPlHd,const YsShellExtEdit &inShl,YsShellPolygonHandle inPlHd)
{
	YsColor inColor;
	YsVec3 inNormal;
	const YsShellExt::PolygonAttrib *inAttrib=inShl.GetPolygonAttrib(inPlHd);
	inShl.GetColorOfPolygon(inColor,inPlHd);
	inShl.GetNormalOfPolygon(inNormal,inPlHd);

	YsShellExtEdit::StopIncUndo incUndo(outShl);
	outShl.SetPolygonColor(outPlHd,inColor);
	outShl.SetPolygonNormal(outPlHd,inNormal);
	outShl.SetPolygonAttrib(outPlHd,*inAttrib);

	return YSOK;
}

YSRESULT YsShellExt_CopyPolygonAttribColorNormalFaceGroup(YsShellExtEdit &outShl,YsShellPolygonHandle outPlHd,YsShellPolygonHandle inPlHd)
{
	YsShellExtEdit::StopIncUndo incUndo(outShl);

	YsShellExt::FaceGroupHandle fgHd=outShl.FindFaceGroupFromPolygon(inPlHd);
	outShl.DeleteFaceGroupPolygon(outPlHd);
	if(NULL!=fgHd)
	{
		const YsShellPolygonHandle fgPlHd[1]={outPlHd};
		outShl.AddFaceGroupPolygon(fgHd,1,fgPlHd);
	}

	return YsShellExt_CopyPolygonAttribColorNormal(outShl,outPlHd,outShl,inPlHd);
}
