uniform mat4 projection;
uniform mat4 modelView;
uniform "YS_GLSL_MIDP" float viewportWid,viewportHei;
uniform int viewportOrigin;

uniform int markerType;
uniform "YS_GLSL_MIDP" float dimension;

attribute "YS_GLSL_HIGHP" vec3 vertex;
attribute "YS_GLSL_MIDP" vec2 pixelOffset;
attribute "YS_GLSL_LOWP" vec4 colorIn;

varying "YS_GLSL_MIDP" vec2 offsetOut;
varying "YS_GLSL_LOWP" vec4 color;

#include "YS_GLSL_FOG_VARIABLES.glsl"
#include "YS_GLSL_ZOFFSET_VARIABLE.glsl"

void main()
{
	#include "YS_GLSL_VIEW_TRANSFORM_IN_VERTEX_SHADER.glsl"
	#include "YS_GLSL_FOG_CALCULATION_IN_VERTEXSHADER.glsl"
	#include "YS_GLSL_PROJECTION_TRANSFORM_IN_VERTEX_SHADER.glsl"
	#include "YS_GLSL_ZOFFSET_IN_VERTEXSHADER.glsl"
	float xOffset=((2.0*pixelOffset.x)/viewportWid)*gl_Position[3];
	float yOffset=((2.0*pixelOffset.y)/viewportHei)*gl_Position[3];
	gl_Position.x+=xOffset;
	gl_Position.y+=yOffset;
	offsetOut=pixelOffset;
	color=colorIn;
}
