#ifndef YSGLDEF_IS_INCLUDED
#define YSGLDEF_IS_INCLUDED
/* { */

/* Force Visual C++ to type-mismatching error. */
#pragma warning( error : 4028)
#pragma warning( error : 4047)

#ifndef YSRESULT_IS_DEFINED
#define YSRESULT_IS_DEFINED
/*! Enum for processing result. */
typedef enum
{
	YSERR,  /*!< There were error(s). */
	YSOK    /*!< The process was successful. */
} YSRESULT;
#endif

#ifndef YSBOOL_IS_DEFINED
#define YSBOOL_IS_DEFINED
/*! Enum for boolearn. */
typedef enum
{
	YSFALSE,     /*!< False */
	YSTRUE,      /*!< True */
	YSTFUNKNOWN  /*!< Unable to tell true or false. */
} YSBOOL;
#endif


enum YSGLSL_HALIGN
{
	YSGLSL_HALIGN_LEFT,
	YSGLSL_HALIGN_CENTER,
	YSGLSL_HALIGN_RIGHT
};

enum YSGLSL_VALIGN
{
	YSGLSL_VALIGN_TOP,
	YSGLSL_VALIGN_CENTER,
	YSGLSL_VALIGN_BOTTOM
};

enum YSGLSL_VIEWPORT_ORIGIN {
	YSGLSL_TOPLEFT_AS_ORIGIN,
	YSGLSL_BOTTOMLEFT_AS_ORIGIN
};


#define YSGLSL_TEX_TYPE_NONE                0
#define YSGLSL_TEX_TYPE_TILING              1
#define YSGLSL_TEX_TYPE_BILLBOARD           2
#define YSGLSL_TEX_TYPE_3DTILING            3
#define YSGLSL_TEX_TYPE_ATTRIBUTE           4

#define YSGLSL_TEX_BILLBOARD_PERS           0
#define YSGLSL_TEX_BILLBOARD_ORTHO          1

#define YSGLSL_TEX_WRAP_CUTOFF              0
#define YSGLSL_TEX_WRAP_REPEAT              1

#define YSGLSL_BILLBOARD_CLIPPING_NONE      0
#define YSGLSL_BILLBOARD_CLIPPING_CIRCLE    1

#define YSGLSL_MARKER_TYPE_PLAIN            0
#define YSGLSL_MARKER_TYPE_CIRCLE           1
#define YSGLSL_MARKER_TYPE_RECT             2
#define YSGLSL_MARKER_TYPE_STAR             3
#define YSGLSL_MARKER_TYPE_EMPTY_RECT       4
#define YSGLSL_MARKER_TYPE_EMPTY_CIRCLE     5
#define YSGLSL_MARKER_TYPE_EMPTY_STAR       6

#define YSGLSL_MAX_NUM_LIGHT                8

#ifdef __APPLE_IOS__
#define YS_GLSL_LOWP "lowp "
#define YS_GLSL_MIDP "mediump "
#define YS_GLSL_HIGHP "highp "
#else
#define YS_GLSL_LOWP
#define YS_GLSL_MIDP
#define YS_GLSL_HIGHP
#endif

/* } */
#endif
