#ifndef YSOPENGL_BITMAPRENDERER_IS_INCLUDED
#define YSOPENGL_BITMAPRENDERER_IS_INCLUDED
/* { */

#include "ysgldef.h"

/* Force Visual C++ to type-mismatching error. */
#pragma warning( error : 4028)
#pragma warning( error : 4047)

#ifdef __cplusplus
extern "C" {
#endif

struct YsGLSLBitmapRenderer;

/*! This function creates a bitmap renderer. */
struct YsGLSLBitmapRenderer *YsGLSLCreateBitmapRenderer(void);

/*! This function removes a bitmap renderer. */
void YsGLSLDeleteBitmapRenderer(struct YsGLSLBitmapRenderer *renderer);

/*! This function starts using a bitmap renderer, and returns program ID of 
    the previously-selected shader. */ 
GLuint YsGLSLUseBitmapRenderer(struct YsGLSLBitmapRenderer *renderer);

/*! This function ends using the bitmap renderer that was activated by 
    YsGLSLUseBitmapRenderer function. */
void YsGLSLEndUseBitmapRenderer(struct YsGLSLBitmapRenderer *renderer);

/*! This function draws a RGBA bitmap with a bitmap renderer.  The bitmap 
    renderer must be activated by YsGLSLUseBitmapRenderer function before 
    this function. */
void YsGLSLRenderRGBABitmap2D(
    struct YsGLSLBitmapRenderer *renderer,
    int x,int y,
    enum YSGLSL_HALIGN hAlign,enum YSGLSL_VALIGN vAlign,
    unsigned int wid,unsigned int hei,const unsigned char rgba[]);

/*! To be implemented.  Not available yet. */
void YsGLSLRenderTexture2D(
    struct YsGLSLBitmapRenderer *renderer,
    int x,int y,
    enum YSGLSL_HALIGN hAlign,enum YSGLSL_VALIGN vAlign,
    unsigned int wid,unsigned int hei,GLuint textureId);

#ifdef __cplusplus
}
#endif

/* } */
#endif
