#include "../ysspecialpath.h"

extern "C" bool YsSpecialPath_GetProgramFileName(size_t lBuf,char buf[]);
extern "C" bool YsSpecialPath_GetProgramBaseDir(size_t lBuf,char buf[]);
extern "C" bool YsSpecialPath_GetUserDir(size_t lBuf,char buf[]);
extern "C" bool YsSpecialPath_GetAllUsersDir(size_t lBuf,char buf[]);

static const size_t bufSize=512;

YSRESULT YsSpecialPath::GetProgramFileName(YsString &path)
{
	char buf[bufSize];
	if(true==YsSpecialPath_GetProgramFileName(bufSize,buf))
	{
		path.Set(buf);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetProgramFileName(YsWString &wpath)
{
	YsString path;
	if(YSOK==GetProgramFileName(path))
	{
		wpath.SetUTF8String(path);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetProgramBaseDir(YsString &path)
{
	char buf[bufSize];
	if(true==YsSpecialPath_GetProgramBaseDir(bufSize,buf))
	{
		path.Set(buf);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetProgramBaseDir(YsWString &wpath)
{
	YsString path;
	if(YSOK==GetProgramBaseDir(path))
	{
		wpath.SetUTF8String(path);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetUserDir(YsString &path)
{
	char buf[bufSize];
	if(true==YsSpecialPath_GetUserDir(bufSize,buf))
	{
		path.Set(buf);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetUserDir(YsWString &wpath)
{
	YsString path;
	if(YSOK==GetUserDir(path))
	{
		wpath.SetUTF8String(path);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetUserDocDir(YsString &path)
{
	char buf[bufSize];
	if(true==YsSpecialPath_GetUserDir(bufSize,buf))
	{
		path.MakeFullPathName(buf,"Documents");
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetUserDocDir(YsWString &wpath)
{
	YsString path;
	if(YSOK==GetUserDocDir(path))
	{
		wpath.SetUTF8String(path);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetUserAppDataDir(YsString &path)
{
	char buf[bufSize];
	if(true==YsSpecialPath_GetUserDir(bufSize,buf))
	{
		path.MakeFullPathName(buf,"Library/Application Support");
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetUserAppDataDir(YsWString &wpath)
{
	YsString path;
	if(YSOK==GetUserAppDataDir(path))
	{
		wpath.SetUTF8String(path);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetAllUsersDir(YsString &path)
{
	return YSERR;
}

YSRESULT YsSpecialPath::GetAllUsersDir(YsWString &wpath)
{
	return YSERR;
}

