#include "../ysfileio.h"

#include <direct.h>

const char *YsFileIO::Getcwd(YsString &cwd)
{
	char cwdIn[_MAX_PATH];
	_getcwd(cwdIn,_MAX_PATH);
	cwd.Set(cwdIn);
	return cwd;
}

const wchar_t *YsFileIO::Getcwd(YsWString &cwd)
{
	wchar_t cwdIn[_MAX_PATH];
	_wgetcwd(cwdIn,_MAX_PATH);
	cwd.Set(cwdIn);
	return cwd;
}

YSRESULT YsFileIO::ChDir(const char dirName[])
{
	if(0==_chdir(dirName))
	{
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsFileIO::ChDir(const wchar_t dirName[])
{
	if(0==_wchdir(dirName))
	{
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsFileIO::MkDir(const char dirName[])
{
	if(0==_mkdir(dirName))
	{
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsFileIO::MkDir(const wchar_t dirName[])
{
	if(0==_wmkdir(dirName))
	{
		return YSOK;
	}
	return YSERR;
}

FILE *YsFileIO::Fopen(const wchar_t fn[],const char mode[])
{
	YsWString wmode;
	wmode.SetUTF8String(mode);
	return _wfopen(fn,wmode);
}

FILE *YsFileIO::Fopen(const char fn[],const char mode[])
{
	return fopen(fn,mode);
}

YSRESULT YsFileIO::Remove(const wchar_t fn[])
{
	if(0==_wremove(fn))
	{
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsFileIO::Remove(const char fn[])
{
	if(0==remove(fn))
	{
		return YSOK;
	}
	return YSERR;
}
